Index: c/src/tests/itrontests/itrontask03/init.c
===================================================================
--- c/src/tests/itrontests/itrontask03/init.c	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ c/src/tests/itrontests/itrontask03/init.c	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -1,3 +1,3 @@
- /*  Init
+/*  Init
  *
  *  This routine is the initialization task for this test program.
@@ -21,4 +21,5 @@
 #include "system.h"
 #include <stdio.h>
+#include <assert.h>
 
 void ITRON_Init( void )
@@ -26,22 +27,57 @@
   ER                status;
   T_CTSK            pk_ctsk;
-
-  puts( "\n\n*** ITRON TASK TEST 3 ***" );
+  T_RTSK            pk_rtsk;
 
   pk_ctsk.exinf    = NULL;
   pk_ctsk.tskatr   = TA_HLNG;
   pk_ctsk.stksz    = RTEMS_MINIMUM_STACK_SIZE; 
+  pk_ctsk.itskpri  = PREEMPT_PRIORITY; 
+  pk_ctsk.task     = Preempt_task;
 
-  pk_ctsk.itskpri  = 1; 
-  pk_ctsk.task     = Preempt_task;
+  puts( "\n\n*** ITRON TASK TEST 3 ***" );
+
+  /*
+   *  Create and start the Preempt task the first time.
+   *  Verify that it is dormant when it comes back.
+   */
+
+  puts( "INIT - Create and Start PREEMPT" );
+  status = chg_pri( TSK_SELF, (PREEMPT_PRIORITY+2) );
+  directive_failed( status, "chg_pri of SELF" );
+  
   status = cre_tsk(  PREEMPT_TASK_ID, &pk_ctsk );
   directive_failed( status, "cre_tsk of RTEMS_PREEMPT" );
+
   status  = sta_tsk( PREEMPT_TASK_ID, 0 );
   directive_failed( status, "sta_tsk of RTEMS_PREEMPT" );
+  puts( "INIT - rot_rdq - no tasks at this priority" );
+  status = rot_rdq( 1 );
+  directive_failed( status, "rot_rdq" );
 
+  puts( "INIT - ref_tsk PREEMPT - Validate DORMANT STATE" );
+  status = ref_tsk( &pk_rtsk, PREEMPT_TASK_ID );
+  directive_failed( status, "INIT - ref_tsk of RTEMS_PREEMPT");
+  assert( pk_rtsk.tskstat == TTS_DMT );
+  
+  /*
+   * Restart the Preempt Task.
+   */
+
+  status  = sta_tsk( PREEMPT_TASK_ID, 0 );
+  directive_failed( status, "sta_tsk of RTEMS_PREEMPT" );
   puts( "INIT - rot_rdq - yielding processor" );
   status = rot_rdq( 1 );
   directive_failed( status, "rot_rdq" );
+  puts( "INIT - ref_tsk PREEMPT - Validate no longer exists" );
+  status = ref_tsk( &pk_rtsk, PREEMPT_TASK_ID );
+  assert( status == E_NOEXS );
 
+  status = chg_pri( TSK_SELF, PREEMPT_PRIORITY );
+  directive_failed( status, "chg_pri of SELF" );
+  
+  /*
+   * XXX 
+   */
+	
   pk_ctsk.itskpri  = 3; 
   pk_ctsk.task     = Task_1;
@@ -63,8 +99,15 @@
   status  = sta_tsk( TA3_ID, 0 );
   directive_failed( status, "sta_tsk of TA3" );
+  puts( "INIT - ref_tsk TA1 - Validate READY STATE" );
+  status = ref_tsk( &pk_rtsk, TA1_ID);
+  directive_failed( status, "INIT - ref_tsk of TA1");
+  assert( pk_rtsk.tskstat == TTS_RDY );
 
   puts( "INIT - suspending TA2 while middle task on a ready chain" );
   status = sus_tsk( TA2_ID  );
   directive_failed( status, "sus_tsk of TA2" );
+  status = ref_tsk( &pk_rtsk, TA2_ID);
+  directive_failed( status, "INIT - ref_tsk of TA2");
+  assert( pk_rtsk.tskstat == TTS_SUS );
 
   status = ter_tsk( TA1_ID );
@@ -90,5 +133,10 @@
   
   exd_tsk();
-  directive_failed( 0, "exd_tsk" );
+  assert(0);
 }
 
+
+
+
+
+
Index: c/src/tests/itrontests/itrontask03/itrontask03.scn
===================================================================
--- c/src/tests/itrontests/itrontask03/itrontask03.scn	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ c/src/tests/itrontests/itrontask03/itrontask03.scn	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -1,5 +1,13 @@
 *** ITRON TASK TEST 3 ***
+INIT - Create and Start PREEMPT
+PREEMPT - ref_tsk validation
+PREEMPT - chg_pri increment priority 
+PREEMPT - ext_tsk - going to DORMANT state
+INIT - rot_rdq - no tasks at this priority
+INIT - ref_tsk PREEMPT - Validate DORMANT STATE
+PREEMPT - ref_tsk validation
+PREEMPT - exd_tsk - Exit and Delete task
 INIT - rot_rdq - yielding processor
-PREEMPT - exd_tsk
+INIT - ref_tsk PREEMPT - Validate no longer exists
 INIT - suspending TA2 while middle task on a ready chain
 TA1 - rtems_task_wake_after - sleep 1 second
@@ -11,3 +19,3 @@
 TA1 - rtems_task_wake_after - sleep for 5 seconds
 TA3 - exd_tsk - exit and delete self
-*** END OF ITRON TASK TEST 3 ***
+*** ITRON TASK TEST 3 ***
Index: c/src/tests/itrontests/itrontask03/preempt.c
===================================================================
--- c/src/tests/itrontests/itrontask03/preempt.c	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ c/src/tests/itrontests/itrontask03/preempt.c	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -22,10 +22,34 @@
 #include "system.h"
 
+int Preempt_task_Count;
+
 void Preempt_task()
 {
-  ER   status;
+  ER       status;
+  T_RTSK   pk_rtsk;
 
-  puts( "PREEMPT - exd_tsk"  );
-  exd_tsk(  );
-  assert( 0 );
+  puts( "PREEMPT - ref_tsk validation"  );
+  status = ref_tsk( &pk_rtsk, PREEMPT_TASK_ID );
+  assert( status          == E_OK );
+  assert( pk_rtsk.tskpri  == PREEMPT_PRIORITY );
+  assert( pk_rtsk.itskpri == PREEMPT_PRIORITY );
+  assert( pk_rtsk.task    == Preempt_task );
+  assert( pk_rtsk.stksz   >= RTEMS_MINIMUM_STACK_SIZE );
+  assert( pk_rtsk.tskstat == (TTS_RUN | TTS_RDY) );
+
+  if ( Preempt_task_Count == 0 ) {
+    Preempt_task_Count ++;
+    puts( "PREEMPT - chg_pri increment priority "); 
+    status = chg_pri( PREEMPT_TASK_ID, (PREEMPT_PRIORITY+1) );
+    directive_failed( status, "chg_pri" );
+    puts( "PREEMPT - ext_tsk - going to DORMANT state" );
+    ext_tsk( );
+    assert( 0 );
+  } else {
+    Preempt_task_Count ++;
+    puts( "PREEMPT - exd_tsk - Exit and Delete task" );
+    exd_tsk(  );
+    assert( 0 );
+  }
 }
+
Index: c/src/tests/itrontests/itrontask03/system.h
===================================================================
--- c/src/tests/itrontests/itrontask03/system.h	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ c/src/tests/itrontests/itrontask03/system.h	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -41,4 +41,6 @@
 #define TA3_ID                  5
 
+
+#define PREEMPT_PRIORITY        1
 TEST_EXTERN rtems_id Global_variable;   /* example global variable     */
 
Index: testsuites/itrontests/itrontask03/init.c
===================================================================
--- testsuites/itrontests/itrontask03/init.c	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ testsuites/itrontests/itrontask03/init.c	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -1,3 +1,3 @@
- /*  Init
+/*  Init
  *
  *  This routine is the initialization task for this test program.
@@ -21,4 +21,5 @@
 #include "system.h"
 #include <stdio.h>
+#include <assert.h>
 
 void ITRON_Init( void )
@@ -26,22 +27,57 @@
   ER                status;
   T_CTSK            pk_ctsk;
-
-  puts( "\n\n*** ITRON TASK TEST 3 ***" );
+  T_RTSK            pk_rtsk;
 
   pk_ctsk.exinf    = NULL;
   pk_ctsk.tskatr   = TA_HLNG;
   pk_ctsk.stksz    = RTEMS_MINIMUM_STACK_SIZE; 
+  pk_ctsk.itskpri  = PREEMPT_PRIORITY; 
+  pk_ctsk.task     = Preempt_task;
 
-  pk_ctsk.itskpri  = 1; 
-  pk_ctsk.task     = Preempt_task;
+  puts( "\n\n*** ITRON TASK TEST 3 ***" );
+
+  /*
+   *  Create and start the Preempt task the first time.
+   *  Verify that it is dormant when it comes back.
+   */
+
+  puts( "INIT - Create and Start PREEMPT" );
+  status = chg_pri( TSK_SELF, (PREEMPT_PRIORITY+2) );
+  directive_failed( status, "chg_pri of SELF" );
+  
   status = cre_tsk(  PREEMPT_TASK_ID, &pk_ctsk );
   directive_failed( status, "cre_tsk of RTEMS_PREEMPT" );
+
   status  = sta_tsk( PREEMPT_TASK_ID, 0 );
   directive_failed( status, "sta_tsk of RTEMS_PREEMPT" );
+  puts( "INIT - rot_rdq - no tasks at this priority" );
+  status = rot_rdq( 1 );
+  directive_failed( status, "rot_rdq" );
 
+  puts( "INIT - ref_tsk PREEMPT - Validate DORMANT STATE" );
+  status = ref_tsk( &pk_rtsk, PREEMPT_TASK_ID );
+  directive_failed( status, "INIT - ref_tsk of RTEMS_PREEMPT");
+  assert( pk_rtsk.tskstat == TTS_DMT );
+  
+  /*
+   * Restart the Preempt Task.
+   */
+
+  status  = sta_tsk( PREEMPT_TASK_ID, 0 );
+  directive_failed( status, "sta_tsk of RTEMS_PREEMPT" );
   puts( "INIT - rot_rdq - yielding processor" );
   status = rot_rdq( 1 );
   directive_failed( status, "rot_rdq" );
+  puts( "INIT - ref_tsk PREEMPT - Validate no longer exists" );
+  status = ref_tsk( &pk_rtsk, PREEMPT_TASK_ID );
+  assert( status == E_NOEXS );
 
+  status = chg_pri( TSK_SELF, PREEMPT_PRIORITY );
+  directive_failed( status, "chg_pri of SELF" );
+  
+  /*
+   * XXX 
+   */
+	
   pk_ctsk.itskpri  = 3; 
   pk_ctsk.task     = Task_1;
@@ -63,8 +99,15 @@
   status  = sta_tsk( TA3_ID, 0 );
   directive_failed( status, "sta_tsk of TA3" );
+  puts( "INIT - ref_tsk TA1 - Validate READY STATE" );
+  status = ref_tsk( &pk_rtsk, TA1_ID);
+  directive_failed( status, "INIT - ref_tsk of TA1");
+  assert( pk_rtsk.tskstat == TTS_RDY );
 
   puts( "INIT - suspending TA2 while middle task on a ready chain" );
   status = sus_tsk( TA2_ID  );
   directive_failed( status, "sus_tsk of TA2" );
+  status = ref_tsk( &pk_rtsk, TA2_ID);
+  directive_failed( status, "INIT - ref_tsk of TA2");
+  assert( pk_rtsk.tskstat == TTS_SUS );
 
   status = ter_tsk( TA1_ID );
@@ -90,5 +133,10 @@
   
   exd_tsk();
-  directive_failed( 0, "exd_tsk" );
+  assert(0);
 }
 
+
+
+
+
+
Index: testsuites/itrontests/itrontask03/itrontask03.scn
===================================================================
--- testsuites/itrontests/itrontask03/itrontask03.scn	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ testsuites/itrontests/itrontask03/itrontask03.scn	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -1,5 +1,13 @@
 *** ITRON TASK TEST 3 ***
+INIT - Create and Start PREEMPT
+PREEMPT - ref_tsk validation
+PREEMPT - chg_pri increment priority 
+PREEMPT - ext_tsk - going to DORMANT state
+INIT - rot_rdq - no tasks at this priority
+INIT - ref_tsk PREEMPT - Validate DORMANT STATE
+PREEMPT - ref_tsk validation
+PREEMPT - exd_tsk - Exit and Delete task
 INIT - rot_rdq - yielding processor
-PREEMPT - exd_tsk
+INIT - ref_tsk PREEMPT - Validate no longer exists
 INIT - suspending TA2 while middle task on a ready chain
 TA1 - rtems_task_wake_after - sleep 1 second
@@ -11,3 +19,3 @@
 TA1 - rtems_task_wake_after - sleep for 5 seconds
 TA3 - exd_tsk - exit and delete self
-*** END OF ITRON TASK TEST 3 ***
+*** ITRON TASK TEST 3 ***
Index: testsuites/itrontests/itrontask03/preempt.c
===================================================================
--- testsuites/itrontests/itrontask03/preempt.c	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ testsuites/itrontests/itrontask03/preempt.c	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -22,10 +22,34 @@
 #include "system.h"
 
+int Preempt_task_Count;
+
 void Preempt_task()
 {
-  ER   status;
+  ER       status;
+  T_RTSK   pk_rtsk;
 
-  puts( "PREEMPT - exd_tsk"  );
-  exd_tsk(  );
-  assert( 0 );
+  puts( "PREEMPT - ref_tsk validation"  );
+  status = ref_tsk( &pk_rtsk, PREEMPT_TASK_ID );
+  assert( status          == E_OK );
+  assert( pk_rtsk.tskpri  == PREEMPT_PRIORITY );
+  assert( pk_rtsk.itskpri == PREEMPT_PRIORITY );
+  assert( pk_rtsk.task    == Preempt_task );
+  assert( pk_rtsk.stksz   >= RTEMS_MINIMUM_STACK_SIZE );
+  assert( pk_rtsk.tskstat == (TTS_RUN | TTS_RDY) );
+
+  if ( Preempt_task_Count == 0 ) {
+    Preempt_task_Count ++;
+    puts( "PREEMPT - chg_pri increment priority "); 
+    status = chg_pri( PREEMPT_TASK_ID, (PREEMPT_PRIORITY+1) );
+    directive_failed( status, "chg_pri" );
+    puts( "PREEMPT - ext_tsk - going to DORMANT state" );
+    ext_tsk( );
+    assert( 0 );
+  } else {
+    Preempt_task_Count ++;
+    puts( "PREEMPT - exd_tsk - Exit and Delete task" );
+    exd_tsk(  );
+    assert( 0 );
+  }
 }
+
Index: testsuites/itrontests/itrontask03/system.h
===================================================================
--- testsuites/itrontests/itrontask03/system.h	(revision 0f88857a3a0793cb494a40cc61954e2f01ef0ef8)
+++ testsuites/itrontests/itrontask03/system.h	(revision 06380cfeac48b3963f9abd5fe256cd73d845bcd3)
@@ -41,4 +41,6 @@
 #define TA3_ID                  5
 
+
+#define PREEMPT_PRIORITY        1
 TEST_EXTERN rtems_id Global_variable;   /* example global variable     */
 