Index: c/src/lib/libbsp/m68k/ods68302/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,18 +6,18 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302
+top_builddir = ../../..
+subdir = libbsp/m68k/ods68302
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/directory.cfg
 
-SRCS=README
+INSTALL_CHANGE = @INSTALL_CHANGE@
+
+SRCS = README
 
 all: $(SRCS)
@@ -25,7 +25,7 @@
 # wrapup is the one that actually builds and installs the library
 #  from the individual .rel files built in other directories
-SUB_DIRS=include start302 startup clock console timer wrapup
+SUB_DIRS = include start302 startup clock console timer wrapup
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/clock/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/clock/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/clock/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,28 +6,28 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/clock
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/clock
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-PGM=${ARCH}/clock.rel
+PGM = ${ARCH}/clock.rel
 
 # C source names, if any, go here -- minus the .c
-C_PIECES=ckinit
-C_FILES=$(C_PIECES:%=%.c)
-C_O_FILES=$(C_PIECES:%=${ARCH}/%.o)
+C_PIECES = ckinit
+C_FILES = $(C_PIECES:%=%.c)
+C_O_FILES = $(C_PIECES:%=${ARCH}/%.o)
 
-H_FILES=
+H_FILES =
 
-SRCS=$(C_FILES) $(H_FILES)
-OBJS=$(C_O_FILES)
+SRCS = $(C_FILES) $(H_FILES)
+OBJS = $(C_O_FILES)
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/leaf.cfg
+
+INSTALL_CHANGE = @INSTALL_CHANGE@
 
 #
@@ -35,11 +35,11 @@
 #
 
-DEFINES  +=
+DEFINES +=
 CPPFLAGS +=
-CFLAGS   +=
+CFLAGS +=
 
-LD_PATHS  +=
-LD_LIBS   +=
-LDFLAGS   +=
+LD_PATHS +=
+LD_LIBS +=
+LDFLAGS +=
 
 #
@@ -56,10 +56,10 @@
 	$(make-rel)
 
-all:	${ARCH} $(SRCS) $(PGM)
+all: ${ARCH} $(SRCS) $(PGM)
 
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-install:  all
+install: all
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/console/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/console/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/console/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,28 +6,28 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/console
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/console
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-PGM=${ARCH}/console.rel
+PGM = ${ARCH}/console.rel
 
 # C source names, if any, go here -- minus the .c
-C_PIECES=console
-C_FILES=$(C_PIECES:%=%.c)
-C_O_FILES=$(C_PIECES:%=${ARCH}/%.o)
+C_PIECES = console
+C_FILES = $(C_PIECES:%=%.c)
+C_O_FILES = $(C_PIECES:%=${ARCH}/%.o)
 
-H_FILES=
+H_FILES =
 
-SRCS=$(C_FILES) $(H_FILES)
-OBJS=$(C_O_FILES)
+SRCS = $(C_FILES) $(H_FILES)
+OBJS = $(C_O_FILES)
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/leaf.cfg
+
+INSTALL_CHANGE = @INSTALL_CHANGE@
 
 #
@@ -35,11 +35,11 @@
 #
 
-DEFINES  +=
+DEFINES +=
 CPPFLAGS +=
-CFLAGS   +=
+CFLAGS +=
 
-LD_PATHS  +=
-LD_LIBS   +=
-LDFLAGS   +=
+LD_PATHS +=
+LD_LIBS +=
+LDFLAGS +=
 
 #
@@ -56,10 +56,10 @@
 	$(make-rel)
 
-all:	${ARCH} $(SRCS) $(PGM)
+all: ${ARCH} $(SRCS) $(PGM)
 
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-install:  all
+install: all
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/include/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/include/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/include/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,18 +6,14 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/include
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/include
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-H_FILES = $(srcdir)/bare.h $(srcdir)/bsp.h \
-		$(srcdir)/coverhd.h $(srcdir)/crc.h \
-		$(srcdir)/debugport.h \
-		$(srcdir)/m68302scc.h
+H_FILES = $(srcdir)/bare.h $(srcdir)/bsp.h $(srcdir)/coverhd.h \
+    $(srcdir)/crc.h $(srcdir)/debugport.h $(srcdir)/m68302scc.h
 
 #
@@ -31,17 +27,25 @@
 EQ_FILES =
 
-SRCS=$(H_FILES) $(EQ_FILES)
+SRCS = $(H_FILES) $(EQ_FILES)
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/leaf.cfg
+
+INSTALL_CHANGE = @INSTALL_CHANGE@
+mkinstalldirs = $(SHELL) $(top_srcdir)/@RTEMS_TOPdir@/mkinstalldirs
+
+INSTALLDIRS = $(PROJECT_INCLUDE)
+
+$(INSTALLDIRS):
+	@$(mkinstalldirs) $(INSTALLDIRS)
 
 CLEAN_ADDITIONS +=
 CLOBBER_ADDITIONS +=
 
-all:	$(SRCS)
-	$(INSTALL_CHANGE) -m 444 $(H_FILES) $(PROJECT_INCLUDE)
-	$(INSTALL_CHANGE) -m 444 $(EQ_FILES) $(PROJECT_INCLUDE)
+all: $(SRCS)
+	@$(INSTALL_CHANGE) -m 644 $(H_FILES) $(PROJECT_INCLUDE)
+	@$(INSTALL_CHANGE) -m 644 $(EQ_FILES) $(PROJECT_INCLUDE)
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/start/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/start/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/start/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,40 +6,39 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/start302
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/start302
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-PGM=${ARCH}/start302.o
+PGM = ${ARCH}/start302.o
 
 ifeq ($(RTEMS_DEBUGGER),yes)
-RESET_SRC = debugreset
-else
-RESET_SRC = reset
-CFLAGS += -DGDB_MONITOR_ACTIVE
-endif
+RESET_S_PIECES = debugreset reset
+else 
+CFLAGS +=
+endif 
 
 # C source names, if any, go here -- minus the .c
-C_PIECES=cpuboot
-C_FILES=$(C_PIECES:%=%.c)
-C_O_FILES=$(C_PIECES:%=${ARCH}/%.o)
+C_PIECES = cpuboot
+C_FILES = $(C_PIECES:%=%.c)
+C_O_FILES = $(C_PIECES:%=${ARCH}/%.o)
 
-H_FILES=
+H_FILES =
 
 # Assembly source names, if any, go here -- minus the .S
-S_PIECES=$(RESET_SRC)
-S_FILES=$(S_PIECES:%=%.S)
-S_O_FILES=$(S_FILES:%.S=${ARCH}/%.o)
+S_PIECES = $(RESET_S_PIECES)
+S_FILES = $(S_PIECES:%=%.S)
+S_O_FILES = $(S_FILES:%.S=${ARCH}/%.o)
 
-SRCS=$(C_FILES) $(H_FILES) $(S_FILES)
-OBJS=$(S_O_FILES) $(C_O_FILES)
+SRCS = $(C_FILES) $(H_FILES) $(S_FILES)
+OBJS = $(S_O_FILES) $(C_O_FILES)
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/leaf.cfg
+
+INSTALL_CHANGE = @INSTALL_CHANGE@
 
 #
@@ -47,11 +46,11 @@
 #
 
-DEFINES  +=
+DEFINES +=
 CPPFLAGS +=
-CFLAGS   +=
+CFLAGS +=
 
-LD_PATHS  +=
-LD_LIBS   +=
-LDFLAGS   +=
+LD_PATHS +=
+LD_LIBS +=
+LDFLAGS +=
 
 #
@@ -67,12 +66,12 @@
 ${PGM}: ${OBJS}
 	$(make-rel)
-	
-all:	${ARCH} $(SRCS) $(OBJS) $(PGM)
-	$(INSTALL_VARIANT) -m 555 ${PGM} ${PROJECT_RELEASE}/lib
+
+all: ${ARCH} $(SRCS) $(OBJS) $(PGM)
+	$(INSTALL_VARIANT) -m 755 ${PGM} $(PROJECT_RELEASE)/lib
 
 # Install the program(s), appending _g or _p as appropriate.
 # for include files, just use $(INSTALL_CHANGE)
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/start302/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/start302/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/start302/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,40 +6,39 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/start302
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/start302
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-PGM=${ARCH}/start302.o
+PGM = ${ARCH}/start302.o
 
 ifeq ($(RTEMS_DEBUGGER),yes)
-RESET_SRC = debugreset
-else
-RESET_SRC = reset
-CFLAGS += -DGDB_MONITOR_ACTIVE
-endif
+RESET_S_PIECES = debugreset reset
+else 
+CFLAGS +=
+endif 
 
 # C source names, if any, go here -- minus the .c
-C_PIECES=cpuboot
-C_FILES=$(C_PIECES:%=%.c)
-C_O_FILES=$(C_PIECES:%=${ARCH}/%.o)
+C_PIECES = cpuboot
+C_FILES = $(C_PIECES:%=%.c)
+C_O_FILES = $(C_PIECES:%=${ARCH}/%.o)
 
-H_FILES=
+H_FILES =
 
 # Assembly source names, if any, go here -- minus the .S
-S_PIECES=$(RESET_SRC)
-S_FILES=$(S_PIECES:%=%.S)
-S_O_FILES=$(S_FILES:%.S=${ARCH}/%.o)
+S_PIECES = $(RESET_S_PIECES)
+S_FILES = $(S_PIECES:%=%.S)
+S_O_FILES = $(S_FILES:%.S=${ARCH}/%.o)
 
-SRCS=$(C_FILES) $(H_FILES) $(S_FILES)
-OBJS=$(S_O_FILES) $(C_O_FILES)
+SRCS = $(C_FILES) $(H_FILES) $(S_FILES)
+OBJS = $(S_O_FILES) $(C_O_FILES)
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/leaf.cfg
+
+INSTALL_CHANGE = @INSTALL_CHANGE@
 
 #
@@ -47,11 +46,11 @@
 #
 
-DEFINES  +=
+DEFINES +=
 CPPFLAGS +=
-CFLAGS   +=
+CFLAGS +=
 
-LD_PATHS  +=
-LD_LIBS   +=
-LDFLAGS   +=
+LD_PATHS +=
+LD_LIBS +=
+LDFLAGS +=
 
 #
@@ -67,12 +66,12 @@
 ${PGM}: ${OBJS}
 	$(make-rel)
-	
-all:	${ARCH} $(SRCS) $(OBJS) $(PGM)
-	$(INSTALL_VARIANT) -m 555 ${PGM} ${PROJECT_RELEASE}/lib
+
+all: ${ARCH} $(SRCS) $(OBJS) $(PGM)
+	$(INSTALL_VARIANT) -m 755 ${PGM} $(PROJECT_RELEASE)/lib
 
 # Install the program(s), appending _g or _p as appropriate.
 # for include files, just use $(INSTALL_CHANGE)
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/startup/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/startup/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/startup/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,28 +6,36 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/startup
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/startup
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@:@srcdir@/../../shared:@srcdir@/../../../shared
 
-PGM=${ARCH}/startup.rel
+PGM = ${ARCH}/startup.rel
 
 # C source names, if any, go here -- minus the .c
-C_PIECES=crc debugport gdb-hooks bootcard main m68302scc m68k-stub memcheck trace gnatinstallhandler bsplibc bsppost bspstart bspclean sbrk setvec
-C_FILES=$(C_PIECES:%=%.c)
-C_O_FILES=$(C_PIECES:%=${ARCH}/%.o)
+C_PIECES = crc debugport gdb-hooks bootcard main m68302scc m68k-stub \
+    memcheck trace gnatinstallhandler bsplibc bsppost bspstart bspclean sbrk \
+    setvec
+C_FILES = $(C_PIECES:%=%.c)
+C_O_FILES = $(C_PIECES:%=${ARCH}/%.o)
 
-H_FILES=
+H_FILES =
 
-SRCS=$(C_FILES) $(H_FILES)  $(srcdir)/rom $(srcdir)/debugger
-OBJS=$(C_O_FILES)
+SRCS = $(C_FILES) $(H_FILES) $(srcdir)/rom $(srcdir)/debugger
+OBJS = $(C_O_FILES)
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/leaf.cfg
+
+INSTALL_CHANGE = @INSTALL_CHANGE@
+mkinstalldirs = $(SHELL) $(top_srcdir)/@RTEMS_TOPdir@/mkinstalldirs
+
+INSTALLDIRS = $(PROJECT_RELEASE)/lib
+
+$(INSTALLDIRS):
+	@$(mkinstalldirs) $(INSTALLDIRS)
 
 #
@@ -35,11 +43,11 @@
 #
 
-DEFINES  +=
+DEFINES +=
 CPPFLAGS +=
-CFLAGS   +=
+CFLAGS +=
 
-LD_PATHS  +=
-LD_LIBS   +=
-LDFLAGS   +=
+LD_PATHS +=
+LD_LIBS +=
+LDFLAGS +=
 
 #
@@ -56,14 +64,14 @@
 	$(make-rel)
 
-$(srcdir)/rom:
+$(srcdir)/rom: 
 
-$(srcdir)/debugger:
+$(srcdir)/debugger: 
 
-all:	${ARCH} $(SRCS) $(PGM)
-	$(INSTALL_CHANGE) $(srcdir)/linkcmds $(srcdir)/rom $(srcdir)/debugger ${PROJECT_RELEASE}/lib
+all: ${ARCH} $(SRCS) $(PGM)
+	$(INSTALL_CHANGE) $(srcdir)/linkcmds $(srcdir)/rom $(srcdir)/debugger $(PROJECT_RELEASE)/lib
 
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/timer/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/timer/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/timer/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,33 +6,33 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/timer
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/timer
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-PGM=${ARCH}/timer.rel
+PGM = ${ARCH}/timer.rel
 
 # C source names, if any, go here -- minus the .c
-C_PIECES=timer
-C_FILES=$(C_PIECES:%=%.c)
-C_O_FILES=$(C_PIECES:%=${ARCH}/%.o)
+C_PIECES = timer
+C_FILES = $(C_PIECES:%=%.c)
+C_O_FILES = $(C_PIECES:%=${ARCH}/%.o)
 
-H_FILES=
+H_FILES =
 
 # Assembly source names, if any, go here -- minus the .S
-S_PIECES=timerisr
-S_FILES=$(S_PIECES:%=%.S)
-S_O_FILES=$(S_FILES:%.S=${ARCH}/%.o)
+S_PIECES = timerisr
+S_FILES = $(S_PIECES:%=%.S)
+S_O_FILES = $(S_FILES:%.S=${ARCH}/%.o)
 
-SRCS=$(C_FILES) $(H_FILES) $(S_FILES)
-OBJS=$(C_O_FILES) $(S_O_FILES)
+SRCS = $(C_FILES) $(H_FILES) $(S_FILES)
+OBJS = $(C_O_FILES) $(S_O_FILES)
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/leaf.cfg
+
+INSTALL_CHANGE = @INSTALL_CHANGE@
 
 #
@@ -40,11 +40,11 @@
 #
 
-DEFINES  +=
+DEFINES +=
 CPPFLAGS +=
-CFLAGS   +=
+CFLAGS +=
 
-LD_PATHS  +=
-LD_LIBS   +=
-LDFLAGS   +=
+LD_PATHS +=
+LD_LIBS +=
+LDFLAGS +=
 
 #
@@ -61,10 +61,10 @@
 	$(make-rel)
 
-all:	${ARCH} $(SRCS) $(PGM)
+all: ${ARCH} $(SRCS) $(PGM)
 
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-install:  all
+install: all
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
Index: c/src/lib/libbsp/m68k/ods68302/wrapup/Makefile.in
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/wrapup/Makefile.in	(revision c8d91839ff0af2f6cf8bbeeecc6e8f7bbf1315c9)
+++ c/src/lib/libbsp/m68k/ods68302/wrapup/Makefile.in	(revision 6693a68ffa99bfba4a7a8bd57337bf21c550fb1e)
@@ -6,24 +6,26 @@
 srcdir = @srcdir@
 top_srcdir = @top_srcdir@
-top_builddir = ../../../../../../..
-subdir = c/src/lib/libbsp/m68k/ods68302/wrapup
+top_builddir = ../../../..
+subdir = libbsp/m68k/ods68302/wrapup
 
-INSTALL = @INSTALL@
-
-RTEMS_ROOT = $(top_srcdir)/@RTEMS_TOPdir@
+RTEMS_ROOT = @RTEMS_ROOT@
 PROJECT_ROOT = @PROJECT_ROOT@
 
 VPATH = @srcdir@
 
-BSP_PIECES=startup clock console timer
-GENERIC_PIECES=
+BSP_PIECES = startup clock console timer
+GENERIC_PIECES =
 
 # bummer; have to use $foreach since % pattern subst rules only replace 1x
-OBJS=$(foreach piece, $(BSP_PIECES), $(wildcard ../$(piece)/$(ARCH)/*.o)) \
-     $(foreach piece, $(GENERIC_PIECES), ../../../$(piece)/$(ARCH)/$(piece).rel)
-LIB=$(ARCH)/libbsp.a
+OBJS = $(foreach piece, $(BSP_PIECES), $(wildcard ../$(piece)/$(ARCH)/*.o)) \
+    $(foreach piece, $(GENERIC_PIECES), \
+    ../../../$(piece)/$(ARCH)/$(piece).rel)
+LIB = $(ARCH)/libbsp.a
 
-include $(RTEMS_ROOT)/make/custom/${RTEMS_BSP}.cfg
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
 include $(RTEMS_ROOT)/make/lib.cfg
+
+INSTALL = @INSTALL@
+INSTALL_CHANGE = @INSTALL_CHANGE@
 
 #
@@ -31,11 +33,11 @@
 #
 
-DEFINES  +=
+DEFINES +=
 CPPFLAGS +=
-CFLAGS   +=
+CFLAGS +=
 
-LD_PATHS  +=
-LD_LIBS   +=
-LDFLAGS   +=
+LD_PATHS +=
+LD_LIBS +=
+LDFLAGS +=
 
 #
@@ -52,11 +54,11 @@
 	$(make-library)
 
-all:	${ARCH} $(SRCS) $(LIB)
-	$(INSTALL_VARIANT) -m 644 $(LIB) ${PROJECT_RELEASE}/lib
+all: ${ARCH} $(SRCS) $(LIB)
+	$(INSTALL_VARIANT) -m 644 $(LIB) $(PROJECT_RELEASE)/lib
 
-$(PROJECT_ROOT)/${RTEMS_BSP}/lib/bsp_specs: ../bsp_specs
+$(PROJECT_ROOT)/@RTEMS_BSP@/lib/bsp_specs: ../bsp_specs
 	$(INSTALL_DATA) $< $@
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.in $(top_builddir)/config.status
 	cd $(top_builddir) \
 	 && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status