Index: c/src/lib/libbsp/powerpc/mvme3100/i2c/i2c_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/i2c/i2c_init.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme3100/i2c/i2c_init.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -84,5 +84,5 @@
 
 int
-BSP_i2c_initialize()
+BSP_i2c_initialize(void)
 {
 int busno, succ = 0;
Index: c/src/lib/libbsp/powerpc/mvme3100/i2c/mpc8540_i2c.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/i2c/mpc8540_i2c.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme3100/i2c/mpc8540_i2c.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -101,5 +101,5 @@
 static rtems_id syncsem = 0;
 
-static inline int ok_to_block()
+static inline int ok_to_block(void)
 {
 	return syncsem && _System_state_Is_up( _System_state_Get() );
@@ -255,5 +255,5 @@
 
 static void
-rd1byte_noack()
+rd1byte_noack(void)
 {
 uint8_t dum;
Index: c/src/lib/libbsp/powerpc/mvme3100/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/irq/irq_init.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme3100/irq/irq_init.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -29,5 +29,5 @@
 #include <rtems/bspIo.h>
 
-static void nop_func()
+static void nop_func(void)
 {
 	printk("Unhandled IRQ\n");
Index: c/src/lib/libbsp/powerpc/mvme3100/network/tsec.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/network/tsec.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme3100/network/tsec.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -421,5 +421,5 @@
 
 #ifdef __PPC__
-static inline void membarrier()
+static inline void membarrier(void)
 {
 	asm volatile("sync":::"memory");
Index: c/src/lib/libbsp/powerpc/mvme3100/pci/detect_host_bridge.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/pci/detect_host_bridge.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme3100/pci/detect_host_bridge.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -76,5 +76,5 @@
 }
 
-void detect_host_bridge()
+void detect_host_bridge(void)
 {
   OpenPIC = (volatile struct OpenPIC *) (BSP_8540_CCSR_BASE + BSP_OPEN_PIC_BASE_OFFSET);
@@ -109,5 +109,5 @@
 
 void
-BSP_pciConfigDump_early()
+BSP_pciConfigDump_early(void)
 {
 	printk("BUS:SLOT:FUN  VENDOR-DEV_ID: COMMAND STATUS BASE_ADDR0 BASE_ADDR1 IRQ_PIN -> IRQ_LINE\n");
Index: c/src/lib/libbsp/powerpc/mvme3100/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/startup/bspstart.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme3100/startup/bspstart.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -50,5 +50,5 @@
 extern unsigned long __rtems_end[];
 extern void          bsp_cleanup(void);
-extern void			 BSP_vme_config();
+extern void			 BSP_vme_config(void);
 
 SPR_RW(SPRG1)
Index: c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -59,5 +59,5 @@
 
 /* return the interrupt flag */
-int GT64260TWSIintFlag() 
+int GT64260TWSIintFlag(void) 
 {
   unsigned int loop;
@@ -71,5 +71,5 @@
 }
 
-int GT64260TWSIstop() 
+int GT64260TWSIstop(void) 
 {
 
@@ -96,5 +96,5 @@
 }
 
-int GT64260TWSIstart()
+int GT64260TWSIstart(void)
 {
   unsigned int loop;	
Index: c/src/lib/libbsp/powerpc/mvme5500/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/irq/irq_init.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/irq/irq_init.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -25,13 +25,13 @@
  * default on/off function
  */
-static void nop_func(){}
+static void nop_func(void){}
 /*
  * default isOn function
  */
-static int not_connected() {return 0;}
+static int not_connected(void) {return 0;}
 /*
  * default possible isOn function
  */
-static int connected() {return 1;}
+static int connected(void) {return 1;}
 
 static rtems_irq_connect_data     	rtemsIrq[BSP_IRQ_NUMBER];
Index: c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -126,5 +126,5 @@
 static void GTeth_rxprio_setup(struct GTeth_softc *sc);
 static void GTeth_rx_stop(struct GTeth_softc *dc);
-static void GT64260eth_isr();
+static void GT64260eth_isr(void);
 static int GTeth_hash_compute(struct GTeth_softc *sc,unsigned char eaddr[ETHER_ADDR_LEN]);
 static int GTeth_hash_entry_op(struct GTeth_softc *sc, enum GTeth_hash_op op,
@@ -159,5 +159,5 @@
 }
 
-static void GT64260eth_isr()
+static void GT64260eth_isr(void)
 {
   struct GTeth_softc *sc = root_GT64260eth_dev;
Index: c/src/lib/libbsp/powerpc/mvme5500/network/if_1GHz/if_wm.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/network/if_1GHz/if_wm.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/network/if_1GHz/if_wm.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -235,8 +235,8 @@
 static void wm_set_filter(struct wm_softc *sc);
 
-static void i82544EI_isr();
+static void i82544EI_isr(void);
 static void i82544EI_sendpacket(struct wm_softc *sc, struct mbuf *m);
-extern int  pci_mem_find(), pci_io_find(), pci_get_capability();
-extern char * ether_sprintf1();
+extern int  pci_mem_find(), pci_io_find(), pci_get_capability(void);
+extern char * ether_sprintf1(void);
 
 static void i82544EI_irq_on(const rtems_irq_connect_data *irq)
Index: c/src/lib/libbsp/powerpc/mvme5500/pci/pci.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/pci/pci.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/pci/pci.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -13,6 +13,4 @@
  *  found in the file LICENSE in this distribution or at
  *  http://www.rtems.com/rtems/license.html.
- *
- *  pci.c,v 1.2 2002/05/14 17:10:16 joel Exp
  *
  *  Copyright 2004, Brookhaven National Laboratory and
@@ -63,5 +61,5 @@
 
 static int		  numPCIDevs=0;
-extern void pci_interface();
+extern void pci_interface(void);
 
 /* Pack RegNum,FuncNum,DevNum,BusNum,and ConfigEnable for
@@ -248,5 +246,5 @@
  *
  */
-int pci_initialize()
+int pci_initialize(void)
 {
   int deviceFound;
Index: c/src/lib/libbsp/powerpc/mvme5500/pci/pci_interface.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/pci/pci_interface.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/pci/pci_interface.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -87,7 +87,7 @@
 #define ADDR_PIPELINE 0x00020000
 
-void  pciAccessInit();
+void  pciAccessInit(void);
 
-void pci_interface()
+void pci_interface(void)
 {
 
@@ -108,5 +108,5 @@
 /* Use MOTLoad default for Writeback Priority and Buffer Depth 
  */
-void pciAccessInit()
+void pciAccessInit(void)
 {
   unsigned int PciLocal, data;
Index: c/src/lib/libbsp/powerpc/mvme5500/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/startup/bspstart.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/startup/bspstart.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -66,11 +66,11 @@
 BSP_output_char_function_type BSP_output_char = BSP_output_char_via_serial;
 
-extern void _return_to_ppcbug();
+extern void _return_to_ppcbug(void);
 extern unsigned long __rtems_end[];
-extern unsigned get_L1CR(), get_L2CR(), get_L3CR();
+extern unsigned get_L1CR(void), get_L2CR(void), get_L3CR(void);
 extern void bsp_cleanup(void);
-extern Triv121PgTbl BSP_pgtbl_setup();
-extern void BSP_pgtbl_activate();
-extern int I2Cread_eeprom();
+extern Triv121PgTbl BSP_pgtbl_setup(unsigned long);
+extern void BSP_pgtbl_activate(Triv121PgTbl);
+extern int I2Cread_eeprom(unsigned char I2cBusAddr, uint32_t devA2A1A0, uint32_t AddrBytes, unsigned char *pBuff, uint32_t numBytes);
 extern void BSP_vme_config(void);
 
Index: c/src/lib/libbsp/powerpc/mvme5500/vectors/exceptionhandler.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/vectors/exceptionhandler.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/mvme5500/vectors/exceptionhandler.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -61,9 +61,9 @@
 #define SRR1_MCP_EXC	(1<<(31-12))
 
-void
-BSP_printStackTrace();
-
-
-void
+extern void
+BSP_printStackTrace(BSP_Exception_frame* excPtr);
+
+
+extern void
 rtemsReboot(void);
 
Index: c/src/lib/libbsp/powerpc/score603e/irq/FPGA.c
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/irq/FPGA.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/score603e/irq/FPGA.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -8,5 +8,5 @@
  *  http://www.rtems.com/license/LICENSE.
  *
- *  $Id:
+ *  $Id$
  */
 
@@ -23,5 +23,5 @@
  *  initialize FPGA
  */
-void initialize_PCI_bridge ()
+void initialize_PCI_bridge (void)
 {
 #if (!SCORE603E_USE_DINK)
@@ -53,5 +53,5 @@
 }
 
-uint16_t         get_irq_mask()
+uint16_t         get_irq_mask(voi)
 {
   uint16_t          *loc;
@@ -91,5 +91,5 @@
 }
 
-void init_irq_data_register()
+void init_irq_data_register(void)
 {
   uint32_t         index;
@@ -149,5 +149,5 @@
 }
 
-uint16_t         read_and_clear_irq()
+uint16_t         read_and_clear_irq(void)
 {
   uint16_t            irq;
Index: c/src/lib/libbsp/powerpc/score603e/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/irq/irq_init.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/score603e/irq/irq_init.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -40,20 +40,20 @@
 
 extern unsigned int external_exception_vector_prolog_code_size[];
-extern void external_exception_vector_prolog_code();
+extern void external_exception_vector_prolog_code(void);
 extern unsigned int decrementer_exception_vector_prolog_code_size[];
-extern void decrementer_exception_vector_prolog_code();
+extern void decrementer_exception_vector_prolog_code(void);
 
 /*
  * default on/off function
  */
-static void nop_func(){}
+static void nop_func(void){}
 /*
  * default isOn function
  */
-static int not_connected() {return 0;}
+static int not_connected(void) {return 0;}
 /*
  * default possible isOn function
  */
-static int connected() {return 1;}
+static int connected(void) {return 1;}
 
 static rtems_irq_connect_data     	rtemsIrq[BSP_IRQ_NUMBER];
Index: c/src/lib/libbsp/powerpc/score603e/pci/no_host_bridge.c
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/pci/no_host_bridge.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/score603e/pci/no_host_bridge.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -1,4 +1,6 @@
 /*
  *  detect_host_bridge.c
+ *
+ * $Id$
  */
                                                                                 
@@ -19,5 +21,5 @@
  */
 
-void detect_host_bridge()
+void detect_host_bridge(void)
 {
 }
Index: c/src/lib/libbsp/powerpc/score603e/startup/Hwr_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/startup/Hwr_init.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/score603e/startup/Hwr_init.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -1,5 +1,5 @@
 /*  Hwr_init.c
  *
- *  $Id:
+ *  $Id$
  */
 
@@ -70,5 +70,5 @@
 }Harris_RTC;
 
-void init_RTC()
+void init_RTC(void)
 {
   volatile Harris_RTC *the_RTC;
@@ -79,5 +79,5 @@
 }
 
-void init_PCI()
+void init_PCI(void)
 {
 #if (SCORE603E_USE_SDS) | (SCORE603E_USE_OPEN_FIRMWARE) | (SCORE603E_USE_NONE)
Index: c/src/lib/libbsp/powerpc/score603e/startup/genpvec.c
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/startup/genpvec.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/score603e/startup/genpvec.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -51,7 +51,7 @@
 
 /* XXX */
-void init_irq_data_register();
+void init_irq_data_register(void);
 
-void initialize_external_exception_vector ()
+void initialize_external_exception_vector (void)
 {
   int i;
Index: c/src/lib/libbsp/powerpc/shared/flash/flash.c
===================================================================
--- c/src/lib/libbsp/powerpc/shared/flash/flash.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/shared/flash/flash.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -133,5 +133,5 @@
 /* 'flush' input buffer and get an upper-case char from stdin */
 STATIC int
-getUc()
+getUc(void)
 {
 	fseek(stdin, 0, SEEK_END);
Index: c/src/lib/libbsp/powerpc/shared/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/shared/irq/irq_init.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/shared/irq/irq_init.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -50,5 +50,5 @@
 /*
  * default possible isOn function
-static int connected() {return 1;}
+static int connected(void) {return 1;}
  */
 
Index: c/src/lib/libbsp/powerpc/virtex/console/consolelite.c
===================================================================
--- c/src/lib/libbsp/powerpc/virtex/console/consolelite.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/virtex/console/consolelite.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -357,5 +357,5 @@
 }
 
-char inputChar()
+char inputChar(void)
 {
    return (char)xlite_read_polled(0);
Index: c/src/lib/libbsp/powerpc/virtex/opbintctrl/opbintctrl.c
===================================================================
--- c/src/lib/libbsp/powerpc/virtex/opbintctrl/opbintctrl.c	(revision 32cf352584ff3e661d0b175383867207863f87cd)
+++ c/src/lib/libbsp/powerpc/virtex/opbintctrl/opbintctrl.c	(revision 6771a9e7961cf0efb2c4c981bad4dd66a229c8e1)
@@ -38,5 +38,5 @@
  * Retrieve contents of Interrupt Pending Register
  */
-RTEMS_INLINE_ROUTINE uint32_t get_ipr()
+RTEMS_INLINE_ROUTINE uint32_t get_ipr(void)
 {
   uint32_t c = *((volatile uint32_t *) (OPB_INTC_BASE + OPB_INTC_IPR));