Index: bsps/powerpc/shared/exceptions-sources.am
===================================================================
--- bsps/powerpc/shared/exceptions-sources.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
+++ bsps/powerpc/shared/exceptions-sources.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -0,0 +1,14 @@
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc-code-copy.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_address.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_alignment.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_asm_macros.h
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_async_normal.S
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_categories.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_fatal.S
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_global_handler.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_hdl.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_initialize.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_naked.S
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_print.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_prologue.c
+libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc.S
Index: ps/powerpc/shared/exceptions.am
===================================================================
--- bsps/powerpc/shared/exceptions.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ 	(revision )
@@ -1,14 +1,0 @@
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc-code-copy.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_address.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_alignment.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_asm_macros.h
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_async_normal.S
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_categories.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_fatal.S
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_global_handler.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_hdl.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_initialize.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_naked.S
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_print.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc_prologue.c
-libbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/exceptions/ppc_exc.S
Index: c/src/lib/libbsp/powerpc/beatnik/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/beatnik/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/beatnik/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -176,4 +176,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/beatnik/headers.am
Index: c/src/lib/libbsp/powerpc/gen5200/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen5200/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/gen5200/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -117,4 +117,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/gen5200/headers.am
Index: c/src/lib/libbsp/powerpc/gen83xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -89,4 +89,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/gen83xx/headers.am
Index: c/src/lib/libbsp/powerpc/haleakala/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -49,4 +49,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/haleakala/headers.am
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -128,4 +128,4 @@
 include $(top_srcdir)/../../../../automake/subdirs.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/motorola_powerpc/headers.am
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -117,4 +117,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/mpc55xxevb/headers.am
Index: c/src/lib/libbsp/powerpc/mpc8260ads/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mpc8260ads/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/mpc8260ads/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -64,4 +64,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/mpc8260ads/headers.am
Index: c/src/lib/libbsp/powerpc/mvme3100/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/mvme3100/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -108,4 +108,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/mvme3100/headers.am
Index: c/src/lib/libbsp/powerpc/mvme5500/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -95,4 +95,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/mvme5500/headers.am
Index: c/src/lib/libbsp/powerpc/psim/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/psim/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/psim/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -69,4 +69,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/psim/headers.am
Index: c/src/lib/libbsp/powerpc/qemuppc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/qemuppc/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/qemuppc/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -58,4 +58,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/qemuppc/headers.am
Index: c/src/lib/libbsp/powerpc/qoriq/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/qoriq/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -108,4 +108,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/qoriq/headers.am
Index: c/src/lib/libbsp/powerpc/t32mppc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/t32mppc/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/t32mppc/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -70,4 +70,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/t32mppc/headers.am
Index: c/src/lib/libbsp/powerpc/tqm8xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/tqm8xx/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/tqm8xx/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -69,4 +69,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/tqm8xx/headers.am
Index: c/src/lib/libbsp/powerpc/virtex/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/virtex/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -66,4 +66,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/virtex/headers.am
Index: c/src/lib/libbsp/powerpc/virtex4/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex4/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/virtex4/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -52,4 +52,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/virtex4/headers.am
Index: c/src/lib/libbsp/powerpc/virtex5/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex5/Makefile.am	(revision 0f0f249c79fe2e080879596c3b85334a02504980)
+++ c/src/lib/libbsp/powerpc/virtex5/Makefile.am	(revision 6799a78983dd9d9b09ed069feacd9a4e74987667)
@@ -54,4 +54,4 @@
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared.am
-include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions.am
+include $(srcdir)/../../../../../../bsps/powerpc/shared/exceptions-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/virtex5/headers.am